package templates

import scala.util.Try
import scala.xml.Node

final class RepoTemplate(source: Node) extends TradeTemplate(source) {
  override protected[this] val msgNotFound = "No elem found"

  protected[this] def templateTrade: Node = {
    <fpml:trade>
      <fpml:tradeHeader>
        { for (s <- source \ "trade" \ "tradeHeader" \ "partyTradeIdentifier") yield {
            <fpml:partyTradeIdentifier>
              <fpml:partyReference href={ get(Try { (s \ "partyReference").head }, "href") } />
              <fpml:tradeId tradeIdScheme={ get(Try { (s \ "tradeId").head }, "tradeIdScheme") }>{ get(Try { (s \ "tradeId").head }) }</fpml:tradeId>
            </fpml:partyTradeIdentifier>
          }
        }
        {/* for (s <- source \ "trade" \ "tradeHeader" \ "partyTradeInformation") yield {
            <fpml:partyTradeInformation>
              <fpml:partyReference href="SPB01" />
              <fpml:relatedParty>
                <fpml:partyReference href="LEI_vvv" />
                <fpml:role>ClearingOrganization</fpml:role>
              </fpml:relatedParty>
              <fpml:category categoryScheme="http://www.fpml.ru/repository/trade-settlement-type">ОТС</fpml:category>
              <fpml:category categoryScheme="http://www.fpml.ru/repository/trade-settlement-method">C</fpml:category>
              <fpml:executionDateTime>2018-10-05T00:00:00</fpml:executionDateTime>
              <fpml:reportingRegime>
                <fpml:name>RussianFederation</fpml:name>
                <fpml:mandatorilyClearable>true</fpml:mandatorilyClearable>
              </fpml:reportingRegime>
            </fpml:partyTradeInformation>
          }
        */}
        {/*
        <fpml:partyTradeInformation>
          <fpml:partyReference href="SPB01" />
          <fpml:relatedParty>
            <fpml:partyReference href="LEI_vvv" />
            <fpml:role>ClearingOrganization</fpml:role>
          </fpml:relatedParty>
          <fpml:category categoryScheme="http://www.fpml.ru/repository/trade-settlement-type">ОТС</fpml:category>
          <fpml:category categoryScheme="http://www.fpml.ru/repository/trade-settlement-method">C</fpml:category>
          <fpml:executionDateTime>2018-10-05T00:00:00</fpml:executionDateTime>
          <fpml:reportingRegime>
            <fpml:name>RussianFederation</fpml:name>
            <fpml:mandatorilyClearable>true</fpml:mandatorilyClearable>
          </fpml:reportingRegime>
        </fpml:partyTradeInformation>
        <fpml:partyTradeInformation>
          <fpml:partyReference href="LEI_253400S2HGY7JG1JWC41" />
          <fpml:relatedParty>
            <fpml:partyReference href="LEI_12548741" />
            <fpml:role>Client</fpml:role>
            <fpml:type>L</fpml:type>
          </fpml:relatedParty>
          <fpml:relatedParty>
            <fpml:partyReference href="LEI_43382" />
            <fpml:role>ClearingOrganization</fpml:role>
          </fpml:relatedParty>
          <fpml:relatedParty>
            <fpml:partyReference href="TEST" />
            <fpml:role>Party</fpml:role>
          </fpml:relatedParty>
          <fpml:timestamps>
            <fpml:timestamp>
              <fpml:type>InClearingPool</fpml:type>
              <fpml:value>2018-10-09T09:00:00</fpml:value>
            </fpml:timestamp>
            <fpml:timestamp>
              <fpml:type>InPortfolio</fpml:type>
              <fpml:value>2018-10-09T09:00:00</fpml:value>
            </fpml:timestamp>
            <fpml:timestamp>
              <fpml:type>OutPortfolio</fpml:type>
              <fpml:value>2018-10-09T09:00:00</fpml:value>
            </fpml:timestamp>
          </fpml:timestamps>
          <fpml:collateralizationType>Uncollateralized</fpml:collateralizationType>
          <fpml:collateralPortfolio>Fully</fpml:collateralPortfolio>
        </fpml:partyTradeInformation>
        <fpml:partyTradeInformation>
          <fpml:partyReference href="TEST" />
          <fpml:relatedParty>
            <fpml:partyReference href="PASS_9999445555" />
            <fpml:role>Client</fpml:role>
            <fpml:type>TR</fpml:type>
          </fpml:relatedParty>
          <fpml:relatedParty>
            <fpml:partyReference href="LEI_NNN" />
            <fpml:role>ClearingOrganization</fpml:role>
          </fpml:relatedParty>
          <fpml:relatedParty>
            <fpml:partyReference href="LEI_253400S2HGY7JG1JWC41" />
            <fpml:role>Party</fpml:role>
          </fpml:relatedParty>
          <timestamps>
            <timestamp>
              <type>InClearingPool</type>
              <value>2018-10-09T09:00:00</value>
            </timestamp>
            <timestamp>
              <type>InPortfolio</type>
              <value>2018-10-09T09:00:00</value>
            </timestamp>
            <timestamp>
              <type>OutPortfolio</type>
              <value>2018-10-10T10:00:00</value>
            </timestamp>
          </timestamps>
          <fpml:collateralizationType>Uncollateralized</fpml:collateralizationType>
          <fpml:collateralPortfolio>Fully</fpml:collateralPortfolio>
        </fpml:partyTradeInformation>
       */}
      </fpml:tradeHeader>
      <fpmlext:repo xsi:type="rtsrep:Repo">
        <fpml:productId>{ get(Try { (source \ "trade" \ "repo" \ "productType" ).head }) }</fpml:productId>
        <fpml:productId productIdScheme={ get(Try { (source \ "trade" \ "repo" \ "productId" ).head }, "productIdScheme") }>{ get(Try { (source \ "trade" \ "repo" \ "productId" ).head }) }</fpml:productId>
        { val iv = get(Try { (source \ "trade" \ "repo" \ "fixedRateSchedule" \ "initialValue").head })

          if (iv.mkString != msgNotFound)
            <fpmlext:fixedRateSchedule>
              <fpml:initialValue>{ iv }</fpml:initialValue>
            </fpmlext:fixedRateSchedule>
          else
            /* Add different type to template  */
            <fpmlext:floatingRateCalculation>
              <fpml:floatingRateIndex>{ get(Try { (source \ "trade" \ "repo" \ "floatingRateCalculation" \ "floatingRateIndex" ).head }) }</fpml:floatingRateIndex>
            </fpmlext:floatingRateCalculation>
            /*---------------------------------*/
        }
        <fpmlext:dayCountFraction>{ get(Try { (source \ "trade" \ "repo" \ "dayCountFraction" ).head }) }</fpmlext:dayCountFraction>
        <fpmlext:spotLeg xsi:type="rtsrep:RepoTransactionLeg">
          <fpml:buyerPartyReference href={ get(Try { (source \ "trade" \ "repo" \ "spotLeg" \ "buyerPartyReference").head }, "href") } />
          <fpml:sellerPartyReference href={ get(Try { (source \ "trade" \ "repo" \ "spotLeg" \ "sellerPartyReference").head }, "href") } />
          <fpmlext:settlementDate>
            <fpml:adjustableDate>
              <fpml:unadjustedDate>{ get(Try { (source \ "trade" \ "repo" \ "spotLeg" \\ "unadjustedDate").head }) }</fpml:unadjustedDate>
            </fpml:adjustableDate>
          </fpmlext:settlementDate>
          <fpml:settlementAmount>
            <fpml:currency>{ get(Try { (source \ "trade" \ "repo" \ "spotLeg" \\ "currency").head }) }</fpml:currency>
            <fpml:amount>{ get(Try { (source \ "trade" \ "repo" \ "spotLeg" \\ "amount").head }) }</fpml:amount>
          </fpml:settlementAmount>
          {/*
          <fpmlext:collateral xsi:type="rtsrep:CollateralValuation">
            <fpmlext:numberOfUnits>100</fpmlext:numberOfUnits>
            <fpmlext:assetReference href="RU0009109391" />
          </fpmlext:collateral>
          */}
          <rtsrep:deliveryDate>
            <fpml:adjustableDate>
              <fpml:unadjustedDate>{ get(Try { (source \ "trade" \ "repo" \ "spotLeg" \ "deliveryDate" \\ "unadjustedDate").head }) }</fpml:unadjustedDate>
            </fpml:adjustableDate>
          </rtsrep:deliveryDate>
        </fpmlext:spotLeg>
        <fpmlext:forwardLeg xsi:type="rtsrep:ForwardRepoTransactionLeg">
          <fpml:buyerPartyReference href={ get(Try { (source \ "trade" \ "repo" \ "forwardLeg" \ "buyerPartyReference").head }, "href") } />
          <fpml:sellerPartyReference href={ get(Try { (source \ "trade" \ "repo" \ "forwardLeg" \ "sellerPartyReference").head }, "href") } />
          <fpmlext:settlementDate>
            <fpml:adjustableDate>
              <fpml:unadjustedDate>{ get(Try { (source \ "trade" \ "repo" \ "forwardLeg" \ "settlementDate" \\ "unadjustedDate").head }) }</fpml:unadjustedDate>
            </fpml:adjustableDate>
          </fpmlext:settlementDate>
          <fpml:settlementAmount>
            <fpml:currency>{ get(Try { (source \ "trade" \ "repo" \ "forwardLeg" \\ "currency").head }) }</fpml:currency>
            <fpml:amount>{ get(Try { (source \ "trade" \ "repo" \ "forwardLeg" \\ "amount").head }) }</fpml:amount>
          </fpml:settlementAmount>
          <rtsrep:deliveryDate>
            <fpml:adjustableDate>
              <fpml:unadjustedDate>{ get(Try { (source \ "trade" \ "repo" \ "forwardLeg" \ "deliveryDate" \\ "unadjustedDate").head }) }</fpml:unadjustedDate>
            </fpml:adjustableDate>
          </rtsrep:deliveryDate>
        </fpmlext:forwardLeg>
        {/*Its necessary to add instrument choice */}
        <fpml:equity id={ get(Try { (source \ "trade" \ "repo" \ "equity").head }, "id") }>
          <fpml:instrumentId instrumentIdScheme="">{ get(Try { (source \ "trade" \ "repo" \ "equity" \ "instrumentId").head }) }</fpml:instrumentId>
        </fpml:equity>
      </fpmlext:repo>
      <fpml:documentation>
        <fpml:masterAgreement>
          <fpml:masterAgreementId>{ get(Try { (source \ "trade" \ "tradeHeader" \ "partyTradeIdentifier" \ "linkId").head }) }</fpml:masterAgreementId>
        </fpml:masterAgreement>
      </fpml:documentation>
    </fpml:trade>
  }
}
