package templates

import scala.util.Try
import scala.xml.Node

abstract class TradeTemplate(source: Node) extends Template(source) {
  protected[this] def templateTrade: Node

  def template: Node = {
    <signedDocument xmlns="http://www.fpml.ru/repository">
      <document>
        <fpml:nonpublicExecutionReport xmlns:fpml="http://www.fpml.org/FpML-5/recordkeeping"
                                       xmlns:fpmlext="http://www.fpml.org/FpML-5/ext" xmlns:rtsrep="http://www.fpml.ru/repository"
                                       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" fpmlVersion="5-7">
          <fpml:header>
            <fpml:messageId>{ get(Try { (source \ "header" \"messageId").head }) }</fpml:messageId>
            <fpml:sentBy>{ get(Try { (source \ "header" \ "sentBy").head }) }</fpml:sentBy>
            <fpml:sendTo>{ get(Try { (source \ "header" \ "sendTo").head }) }</fpml:sendTo>
            <fpml:creationTimestamp>{ get(Try { (source \ "header" \ "creationTimestamp").head }) }</fpml:creationTimestamp>
            <fpml:implementationSpecification>
              <fpml:version>2</fpml:version>
            </fpml:implementationSpecification>
          </fpml:header>
          <fpml:isCorrection>{ get(Try { (source \ "isCorrection").head }) }</fpml:isCorrection>
          <fpml:correlationId correlationIdScheme="">{get(Try { (source \ "correlationId").head }) }</fpml:correlationId>
          { templateTrade }
          { for (s <- source \ "party") yield {
              <fpml:party id={ get(Try { s.head }, "id") }>
                <fpml:partyId partyIdScheme={ get(Try { (s \ "partyId").head }, "partyIdScheme") }>{ get(Try { (s \ "partyId").head }) }</fpml:partyId>
                <fpml:partyName>{ get(Try { (s \ "partyName").head }) }</fpml:partyName>
                <fpml:country>{ get(Try { (s \ "country").head }) }</fpml:country>
                <fpml:organizationType>{ get(Try { (s \ "classification").head }) }</fpml:organizationType>
              </fpml:party>
            }
          }
        </fpml:nonpublicExecutionReport>
      </document>
    </signedDocument>
  }

}
